package model;

import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import services.dummy.PizzaServiceDummy;

import static org.junit.jupiter.api.Assertions.*;

class PizzaTest {
    private PizzaServiceDummy pizzaServiceDummy = new PizzaServiceDummy();
    private Pizza pizza;

    @BeforeEach
    void setUp() {
        pizza = pizzaServiceDummy.generateRandomPizza();
    }

    @AfterEach
    void tearDown() {
    }

    @Test
    void addTopping() {
        Pizza pizza2 = new Pizza();
        Pizza.Toppings topping = pizzaServiceDummy.getRandomTopping();
        pizza2.addTopping(topping);
        pizza2.addTopping(topping);
        assertThrows(IllegalArgumentException.class, () -> pizza2.addTopping(topping));
    }

    @Test
    void setSize() {
        Pizza.Size size = pizzaServiceDummy.getRandomSize();
        pizza.setSize(size);
        assertEquals(size, pizza.getSize());
        pizza.setSize(Pizza.Size.LARGE);
        assertNotEquals(Pizza.Size.SMALL, pizza.getSize());
    }

    @Test
    void setName() {
        pizza.setName("Test 123");
        assertEquals("Test 123", pizza.getName());
        assertNotEquals("Wrong", pizza.getName());
    }

    @Test
    void removeTopping() {
        Pizza pizza2 = new Pizza();
        Pizza.Toppings topping = pizzaServiceDummy.getRandomTopping();
        pizza2.addTopping(topping);
        pizza2.removeTopping(topping);
        assertFalse(pizza2.getToppings().contains(topping));
    }
}